git-rebase--merge.shon commit rebase: introduce and use pseudo-ref REBASE_HEAD (fbd7a23)
   1# This shell script fragment is sourced by git-rebase to implement
   2# its merge-based non-interactive mode that copes well with renamed
   3# files.
   4#
   5# Copyright (c) 2010 Junio C Hamano.
   6#
   7
   8prec=4
   9
  10read_state () {
  11        onto_name=$(cat "$state_dir"/onto_name) &&
  12        end=$(cat "$state_dir"/end) &&
  13        msgnum=$(cat "$state_dir"/msgnum)
  14}
  15
  16continue_merge () {
  17        test -d "$state_dir" || die "$state_dir directory does not exist"
  18
  19        unmerged=$(git ls-files -u)
  20        if test -n "$unmerged"
  21        then
  22                echo "You still have unmerged paths in your index"
  23                echo "did you forget to use git add?"
  24                die "$resolvemsg"
  25        fi
  26
  27        cmt=$(cat "$state_dir/current")
  28        if ! git diff-index --quiet --ignore-submodules HEAD --
  29        then
  30                if ! git commit ${gpg_sign_opt:+"$gpg_sign_opt"} --no-verify -C "$cmt"
  31                then
  32                        echo "Commit failed, please do not call \"git commit\""
  33                        echo "directly, but instead do one of the following: "
  34                        die "$resolvemsg"
  35                fi
  36                if test -z "$GIT_QUIET"
  37                then
  38                        printf "Committed: %0${prec}d " $msgnum
  39                fi
  40                echo "$cmt $(git rev-parse HEAD^0)" >> "$state_dir/rewritten"
  41        else
  42                if test -z "$GIT_QUIET"
  43                then
  44                        printf "Already applied: %0${prec}d " $msgnum
  45                fi
  46        fi
  47        test -z "$GIT_QUIET" &&
  48        GIT_PAGER='' git log --format=%s -1 "$cmt"
  49
  50        # onto the next patch:
  51        msgnum=$(($msgnum + 1))
  52        echo "$msgnum" >"$state_dir/msgnum"
  53}
  54
  55call_merge () {
  56        msgnum="$1"
  57        echo "$msgnum" >"$state_dir/msgnum"
  58        cmt="$(cat "$state_dir/cmt.$msgnum")"
  59        echo "$cmt" > "$state_dir/current"
  60        git update-ref REBASE_HEAD "$cmt"
  61        hd=$(git rev-parse --verify HEAD)
  62        cmt_name=$(git symbolic-ref HEAD 2> /dev/null || echo HEAD)
  63        eval GITHEAD_$cmt='"${cmt_name##refs/heads/}~$(($end - $msgnum))"'
  64        eval GITHEAD_$hd='$onto_name'
  65        export GITHEAD_$cmt GITHEAD_$hd
  66        if test -n "$GIT_QUIET"
  67        then
  68                GIT_MERGE_VERBOSITY=1 && export GIT_MERGE_VERBOSITY
  69        fi
  70        test -z "$strategy" && strategy=recursive
  71        # If cmt doesn't have a parent, don't include it as a base
  72        base=$(git rev-parse --verify --quiet $cmt^)
  73        eval 'git-merge-$strategy' $strategy_opts $base ' -- "$hd" "$cmt"'
  74        rv=$?
  75        case "$rv" in
  76        0)
  77                unset GITHEAD_$cmt GITHEAD_$hd
  78                return
  79                ;;
  80        1)
  81                git rerere $allow_rerere_autoupdate
  82                die "$resolvemsg"
  83                ;;
  84        2)
  85                echo "Strategy: $strategy failed, try another" 1>&2
  86                die "$resolvemsg"
  87                ;;
  88        *)
  89                die "Unknown exit code ($rv) from command:" \
  90                        "git-merge-$strategy $cmt^ -- HEAD $cmt"
  91                ;;
  92        esac
  93}
  94
  95finish_rb_merge () {
  96        move_to_original_branch
  97        if test -s "$state_dir"/rewritten
  98        then
  99                git notes copy --for-rewrite=rebase <"$state_dir"/rewritten
 100                hook="$(git rev-parse --git-path hooks/post-rewrite)"
 101                test -x "$hook" && "$hook" rebase <"$state_dir"/rewritten
 102        fi
 103        say All done.
 104}
 105
 106# The whole contents of this file is run by dot-sourcing it from
 107# inside a shell function.  It used to be that "return"s we see
 108# below were not inside any function, and expected to return
 109# to the function that dot-sourced us.
 110#
 111# However, older (9.x) versions of FreeBSD /bin/sh misbehave on such a
 112# construct and continue to run the statements that follow such a "return".
 113# As a work-around, we introduce an extra layer of a function
 114# here, and immediately call it after defining it.
 115git_rebase__merge () {
 116
 117case "$action" in
 118continue)
 119        read_state
 120        continue_merge
 121        while test "$msgnum" -le "$end"
 122        do
 123                call_merge "$msgnum"
 124                continue_merge
 125        done
 126        finish_rb_merge
 127        return
 128        ;;
 129skip)
 130        read_state
 131        git rerere clear
 132        msgnum=$(($msgnum + 1))
 133        while test "$msgnum" -le "$end"
 134        do
 135                call_merge "$msgnum"
 136                continue_merge
 137        done
 138        finish_rb_merge
 139        return
 140        ;;
 141show-current-patch)
 142        exec git show REBASE_HEAD --
 143        ;;
 144esac
 145
 146mkdir -p "$state_dir"
 147echo "$onto_name" > "$state_dir/onto_name"
 148write_basic_state
 149rm -f "$(git rev-parse --git-path REBASE_HEAD)"
 150
 151msgnum=0
 152for cmt in $(git rev-list --reverse --no-merges "$revisions")
 153do
 154        msgnum=$(($msgnum + 1))
 155        echo "$cmt" > "$state_dir/cmt.$msgnum"
 156done
 157
 158echo 1 >"$state_dir/msgnum"
 159echo $msgnum >"$state_dir/end"
 160
 161end=$msgnum
 162msgnum=1
 163
 164while test "$msgnum" -le "$end"
 165do
 166        call_merge "$msgnum"
 167        continue_merge
 168done
 169
 170finish_rb_merge
 171
 172}
 173# ... and then we call the whole thing.
 174git_rebase__merge